#
# spec file for package pacemaker (Version 1.0.1)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

%define with_extra_warnings   	0
%define with_debugging  	0
%define without_fatal_warnings 	1
%define with_ais_support        0
%define jobs		        2
%define gname haclient
%define uname hacluster
%define doc_pkg heartbeat-doc-1.0

%if 0%{?suse_version}
%define _libexecdir %{_libdir}
%endif

%if 0%{?fedora_version} || 0%{?centos_version} || 0%{?rhel_version}
%define pkg_group System Environment/Daemons
%else
%define pkg_group Productivity/Clustering/HA
%endif

Name:           pacemaker
Summary:        The Pacemaker scalable High-Availability cluster resource manager
Version:        1.0.1
Release:        6.2.sl5
License:        GPL v2 or later; LGPL v2.1 or later
Url:            http://www.clusterlabs.org
Group:          %{pkg_group}
Source:         pacemaker.tar.gz
Source2:        %{doc_pkg}.tar.gz
Source100:      pacemaker.rpmlintrc
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
AutoReqProv:    on
Conflicts:      heartbeat < 2.99
Requires:       heartbeat-common
Requires:       libpacemaker3 = %{version}-%{release}
Requires:       heartbeat
BuildRequires:  e2fsprogs-devel glib2-devel gnutls-devel libxml2-devel libxslt-devel ncurses-devel pam-devel python-devel swig pkgconfig 
BuildRequires:  heartbeat-devel heartbeat-common libheartbeat-devel
BuildRequires:  which autoconf automake libtool bzip2-devel bzip2-libs mercurial
%if %with_ais_support
BuildRequires:  libopenais-devel
Requires:       openais
%endif

%if 0%{?suse_version}
BuildRequires:  libbz2-devel
%if 0%{?suse_version} > 1100
BuildRequires:  docbook-xsl-stylesheets
%endif
%endif

%if 0%{?fedora_version} || 0%{?centos_version} || 0%{?rhel_version}
BuildRequires:  which autoconf automake libtool
%endif

%if 0%{?mandriva_version}
BuildRequires:  libbzip2-devel
%endif

%description
Pacemaker is an advanced, scalable High-Availability cluster resource
manager for Linux-HA (Heartbeat) and/or OpenAIS.

It supports "n-node" clusters with significant capabilities for
managing resources and dependencies.

It will run scripts at initialization, when machines go up or down,
when related resources fail and can be configured to periodically check
resource health.



Authors:
--------
    Andrew Beekhof <abeekhof@suse.de>

%package -n libpacemaker3
License:        GPL v2 or later; LGPL v2.1 or later
Summary:        The Pacemaker scalable High-Availability cluster resource manager
Group:          Productivity/Clustering/HA

%description -n libpacemaker3
Pacemaker is an advanced, scalable High-Availability cluster resource
manager for Linux-HA (Heartbeat) and/or OpenAIS.

It supports "n-node" clusters with significant capabilities for
managing resources and dependencies.

It will run scripts at initialization, when machines go up or down,
when related resources fail and can be configured to periodically check
resource health.



Authors:
--------
    Andrew Beekhof <abeekhof@suse.de>

%package -n libpacemaker-devel 
License:        GPL v2 only; GPL v2 or later; LGPL v2.1 or later
Summary:        The Pacemaker scalable High-Availability cluster resource manager
Group:          Development/Libraries/C and C++
Requires:       %{name} = %{version}-%{release}
Requires:       libpacemaker3 = %{version}-%{release}
Requires:       libheartbeat-devel

%description -n libpacemaker-devel
Pacemaker is an advanced, scalable High-Availability cluster resource
manager for Linux-HA (Heartbeat) and/or OpenAIS.

It supports "n-node" clusters with significant capabilities for
managing resources and dependencies.

It will run scripts at initialization, when machines go up or down,
when related resources fail and can be configured to periodically check
resource health.



Authors:
--------
    Andrew Beekhof <abeekhof@suse.de>

%prep
###########################################################
%setup -a 2 -n pacemaker -q
###########################################################

%build
# TODO: revisit -all
CFLAGS="${CFLAGS} ${RPM_OPT_FLAGS}"
# Feature-dependent CFLAGS:
%if %with_extra_warnings
# CFLAGS="${CFLAGS} -Wshadow -Wfloat-equal -Waggregate-return -Wnested-externs -Wunreachable-code -Wendif-labels -Winline"
CFLAGS="${CFLAGS} -Wfloat-equal -Wendif-labels -Winline"
%endif
%if %with_debugging
CFLAGS="${CFLAGS} -O0"
%endif
# Distribution specific settings:
%if 0%{?suse_version} > 1001
CFLAGS="${CFLAGS} -fstack-protector-all"
%endif
%if 0%{?suse_version} < 1001
export PKG_CONFIG_PATH="$PKG_CONFIG_PATH:/opt/gnome/%{_lib}/pkgconfig:/opt/gnome/share/pkgconfig"
%endif
%if 0%{?suse_version} > 1020
CFLAGS="$CFLAGS -fgnu89-inline"
%endif
%if 0%{?fedora_version} > 6
CFLAGS="$CFLAGS -fgnu89-inline"
%endif
export CFLAGS
./ConfigureMe configure --prefix=%{_prefix} --sysconfdir=%{_sysconfdir} \
	--localstatedir=%{_var} --infodir=%{_infodir} 		\
	--mandir=%{_mandir} --libdir=%{_libdir} 		\
	--libexecdir=%{_libexecdir} 				\
%if %with_ais_support
	--with-ais-support		      			\
	--with-ais-prefix=%{_prefix}      			\
%else
	--without-ais-support		      			\
%endif
	--with-heartbeat-support         			\
%if %without_fatal_warnings
	--enable-fatal-warnings=no 			        \
%endif
	--with-hapkgversion=%{version}
export MAKE="make %{?jobs:-j%jobs}"
make %{?jobs:-j%jobs}
if [ -e /usr/share/xml/docbook/stylesheet/nwalsh/current ]; then
    make -C %{doc_pkg} man
fi
###########################################################

%install
###########################################################
make DESTDIR=$RPM_BUILD_ROOT install
if [ -e %{doc_pkg}/cibadmin.8 ]; then
    install -d $RPM_BUILD_ROOT/%{_mandir}/man8
    for file in `ls -1 %{doc_pkg}/*.8`; do
	install -p -m 644 $file $RPM_BUILD_ROOT/%{_mandir}/man8
    done
fi
chmod a+x $RPM_BUILD_ROOT/%{_libdir}/heartbeat/crm_primitive.py
chmod a+x $RPM_BUILD_ROOT/%{_libdir}/heartbeat/hb2openais-helper.py
if [[ -e $RPM_BUILD_ROOT/%{_libdir}/service_crm.so ]]; then
    rm $RPM_BUILD_ROOT/%{_libdir}/service_crm.so
fi
(
    cd $RPM_BUILD_ROOT/%{_sbindir}
    rm crm_standby crm_master crm_failcount
    ln crm_attribute crm_standby
    ln crm_attribute crm_master
    ln crm_attribute crm_failcount
)
#%if %with_ais_support
#    mkdir -p $RPM_BUILD_ROOT/%{_libexecdir}/lcrso
#    cp $RPM_BUILD_ROOT/%{_libdir}/service_crm.so $RPM_BUILD_ROOT/%{_libexecdir}/lcrso/pacemaker.lcrso
#%endif
# Cleanup
[ -d $RPM_BUILD_ROOT/usr/man ] && rm -rf $RPM_BUILD_ROOT/usr/man
[ -d $RPM_BUILD_ROOT/usr/share/libtool ] && rm -rf $RPM_BUILD_ROOT/usr/share/libtool
find $RPM_BUILD_ROOT -name '*.a' -type f -print0 | xargs -0 rm -f
find $RPM_BUILD_ROOT -name '*.la' -type f -print0 | xargs -0 rm -f
find $RPM_BUILD_ROOT -name '*.pyc' -type f -print0 | xargs -0 rm -f
find $RPM_BUILD_ROOT -name '*.pyo' -type f -print0 | xargs -0 rm -f
###########################################################

%clean
###########################################################
if
  [ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ]
then
  rm -rf $RPM_BUILD_ROOT
fi
rm -rf $RPM_BUILD_DIR/pacemaker
###########################################################

%post -n libpacemaker3 -p /sbin/ldconfig

%postun -n libpacemaker3 -p /sbin/ldconfig

%files
###########################################################
%defattr(-,root,root)
%dir %{_libdir}/heartbeat
%dir %{_var}/run/heartbeat
%dir %{_var}/lib/heartbeat
%{_datadir}/pacemaker
#%{_datadir}/heartbeat
%{_libdir}/heartbeat/*
%{_sbindir}/cibadmin
%{_sbindir}/crm_attribute
%{_sbindir}/crm_diff
%{_sbindir}/crm_failcount
%{_sbindir}/crm_master
%{_sbindir}/crm_mon
%{_sbindir}/crm
%{_sbindir}/crm_resource
%{_sbindir}/crm_standby
%{_sbindir}/crm_uuid
%{_sbindir}/crm_verify
%{_sbindir}/crmadmin
%{_sbindir}/iso8601
%{_sbindir}/ccm_tool
%{_sbindir}/attrd_updater
%{_sbindir}/ptest
%{_sbindir}/crm_shadow
%{_sbindir}/cibpipe
%doc %{_mandir}/man8/*.8*
%{_datadir}/doc/packages/pacemaker/AUTHORS
%{_datadir}/doc/packages/pacemaker/COPYING
%{_datadir}/doc/packages/pacemaker/COPYING.LGPL
%{_datadir}/doc/packages/pacemaker/README
%{_datadir}/doc/packages/pacemaker/README.hb2openais
%{_datadir}/doc/packages/pacemaker/crm_cli.txt
%dir %attr (750, %{uname}, %{gname}) %{_datadir}/doc
%dir %attr (750, %{uname}, %{gname}) %{_datadir}/doc/packages
%dir %attr (750, %{uname}, %{gname}) %{_datadir}/doc/packages/pacemaker
%dir %attr (750, %{uname}, %{gname}) %{_var}/lib/heartbeat/crm
%dir %attr (750, %{uname}, %{gname}) %{_var}/lib/heartbeat/pengine
%dir %attr (750, %{uname}, %{gname}) %{_var}/run/heartbeat/crm
%dir /usr/lib/ocf
%dir /usr/lib/ocf/resource.d
/usr/lib/ocf/resource.d/pacemaker
%if %with_ais_support
%{_libexecdir}/lcrso/pacemaker.lcrso
%endif

%files -n libpacemaker3
%defattr(-,root,root)
%{_libdir}/libcib.so.*
%{_libdir}/libcrmcommon.so.*
%{_libdir}/libcrmcluster.so.*
%{_libdir}/libpe_status.so.*
%{_libdir}/libpe_rules.so.*
%{_libdir}/libpengine.so.*
%{_libdir}/libtransitioner.so.*
%{_libdir}/libstonithd.so.*

%files -n libpacemaker-devel
%defattr(-,root,root)
#%doc %{_datadir}/doc/%{name}-%{version}
%{_includedir}/pacemaker
%{_includedir}/heartbeat/fencing
%{_libdir}/*.so

%changelog
* Tue Nov 18 2008 Andrew Beekhof <abeekhof@suse.de>
- version 1.0.1-1
- Update source tarball to revision: 6fc5ce8302ab (stable-1.0) tip
- Statistics:
    Changesets:      170
    Diff:            816 files changed, 7633 insertions(+), 6286 deletions(-)
- Changes since Pacemaker-1.0.1
+ High: ais: Allow the crmd to get callbacks whenever a node's state changes
+ High: ais: Create an option for starting the mgmtd daemon automatically
+ High: ais: Ensure HA_RSCTMP exists for use by resource agents
+ High: ais: Hook up the openais.conf config logging options
+ High: ais: Zero out the PID of disconnecting clients
+ High: cib: Ensure global updates cause a disk write when appropriate
+ High: Core: Add an extra snaity check to getXpathResults() to prevent segfaults
+ High: Core: Don't redefine __FUNCTION__ unnecessarily
+ High: Core: Repair the ability to have comments in the configuration
+ High: crmd: Bug:1975 - crmd should wait indefinitely for stonith operations to complete
+ High: crmd: Ensure PE processing does not occur for all error cases in do_pe_invoke_callback
+ High: crmd: Requests to the CIB should cause any prior PE calculations to be ignored
+ High: heartbeat: Wait for membership 'up' events before removing stale node status data
+ High: PE: Bug LF:1988 - Ensure recurring operations always have the correct target-rc set
+ High: PE: Bug LF:1988 - For unmanaged resources we need to skip the usual can_run_resources() checks
+ High: PE: Ensure the terminate node attribute is handled correctly
+ High: PE: Fix optional colocation
+ High: PE: Improve up the detection of 'new' nodes joining the cluster
+ High: PE: Prevent assert failures in master_color() by ensuring unmanaged masters are always reallocated to their current location
+ High: Tools: crm cli: parser: return False on syntax error and None for comments
+ High: Tools: crm cli: unify template and edit commands
+ High: Tools: crm_shadow - Show more line number information after validation failures
+ High: Tools: hb2openais: add option to upgrade the CIB to v3.0
+ High: Tools: hb2openais: add U option to getopts and update usage
+ High: Tools: hb2openais: backup improved and multiple fixes
+ High: Tools: hb2openais: fix class/provider reversal
+ High: Tools: hb2openais: fix testing
+ High: Tools: hb2openais: move the CIB update to the end
+ High: Tools: hb2openais: update logging and set logfile appropriately
+ High: Tools: LF:1969 - Attrd never sets any properties in the cib
+ High: Tools: Make attrd functional on OpenAIS
+ Medium: ais: Hook up the options for specifying the expected number of nodes and total quorum votes
+ Medium: ais: Look for pacemaker options inside the service block with 'name: pacemaker' instead of creating an addtional configuration block
+ Medium: ais: Provide better feedback when nodes change nodeid's (in openais.conf)
+ Medium: cib: Always store cib contents on disk with num_updates=0
+ Medium: cib: Ensure remote access ports are cleaned up on shutdown
+ Medium: crmd: Detect deleted resource operations automatically
+ Medium: crmd: Erase a node's resource operations and transient attributes after a successful STONITH
+ Medium: crmd: Find a more appropriate place to update quorum and refresh attrd attributes
+ Medium: crmd: Fix the handling of unexpected PE exits to ensure the current CIB is stored
+ Medium: crmd: Fix the recording of pending operations in the CIB
+ Medium: crmd: Initiate an attrd refresh _after_ the status section has been fully repopulated
+ Medium: crmd: Only the DC should update quorum in an openais cluster
+ Medium: Ensure meta attributes are used consistantly
+ Medium: PE: Allow group and clone level resource attributes
+ Medium: PE: Bug N:437719 - Ensure scores from colocated resources count when allocating groups
+ Medium: PE: Prevent lsb scripts from being used in globally unique clones
+ Medium: PE: Make a best-effort guess at a migration threshold for people with 0.6 configs
+ Medium: Resources: controld - ensure we are part of a clone with globally_unique=false
+ Medium: Tools: attrd - Automatically refresh all attributes after a CIB replace operation
+ Medium: Tools: Bug LF:1985 - crm_mon - Correctly process failed cib queries to allow reconnection after cluster restarts
+ Medium: Tools: Bug LF:1987 - crm_verify incorrectly warns of configuration upgrades for the most recent version
+ Medium: Tools: crm (bnc#441028): check for key error in attributes management
+ Medium: Tools: crm_mon - display the meaning of the operation's rc code instead of the status
+ Medium: Tools: crm_mon - Fix the display of timing data
+ Medium: Tools: crm_verify - check that we're being asked to validate a complete config
+ Medium: xml: Relax the restriction on the contents of rsc_locaiton.node
* Thu Oct 16 2008 Andrew Beekhof <abeekhof@suse.de>
- version 1.0.0-1
- Update source tarball to revision: 388654dfef8f tip
- Statistics:
    Changesets:      261
    Diff:            3021 files changed, 244985 insertions(+), 111596 deletions(-)
- Changes since f805e1b30103
+ High: add the crm cli program
+ High: ais: Move the service id definition to a common location and make sure it is always used
+ High: build: rename hb2openais.sh to .in and replace paths with vars
+ High: cib: Implement --create for crm_shadow
+ High: cib: Remove dead files
+ High: Core: Allow the expected number of quorum votes to be configrable
+ High: Core: cl_malloc and friends were removed from Heartbeat
+ High: Core: Only call xmlCleanupParser() if we parsed anything.  Doing so unconditionally seems to cause a segfault
+ High: hb2openais.sh: improve pingd handling; several bugs fixed
+ High: hb2openais: fix clone creation; replace EVMS strings
+ High: new hb2openais.sh conversion script
+ High: PE: Bug LF:1950 - Ensure the current values for all notification variables are always set (even if empty)
+ High: PE: Bug LF:1955 - Ensure unmanaged masters are unconditionally repromoted to ensure they are monitored correctly.
+ High: PE: Bug LF:1955 - Fix another case of filtering causing unmanaged master failures
+ High: PE: Bug LF:1955 - Umanaged mode prevents master resources from being allocated correctly
+ High: PE: Bug N:420538 - Anit-colocation caused a positive node preference
+ High: PE: Correctly handle unmanaged resources to prevent them from being started elsewhere
+ High: PE: crm_resource - Fix the --migrate command
+ High: PE: MAke stonith-enabled default to true and warn if no STONITH resources are found
+ High: PE: Make sure orphaned clone children are created correctly
+ High: PE: Monitors for unmanaged resources don't need to wait for start/promote/demote actions to complete
+ High: stonithd (LF 1951): fix remote stonith operations
+ High: stonithd: fix handling of timeouts
+ High: stonithd: fix logic for stonith resource priorities
+ High: stonithd: implement the fence-timeout instance attribute
+ High: stonithd: initialize value before reading fence-timeout
+ High: stonithd: set timeouts for fencing ops to the timeout of the start op
+ High: stonithd: stonith rsc priorities (new feature)
+ High: Tools: Add hb2openais - a tool for upgrading a Heartbeat cluster to use OpenAIS instead
+ High: Tools: crm_verify - clean up the upgrade logic to prevent crash on invalid configurations
+ High: Tools: Make pingd functional on Linux
+ High: Update version numbers for 1.0 candidates
+ Medium: ais: Add support for a synchronous call to retrieve the node's nodeid
+ Medium: ais: Use the agreed service number
+ Medium: Build: Reliably detect heartbeat libraries during configure
+ Medium: Build: Supply prototypes for libreplace functions when needed
+ Medium: Build: Teach configure how to find corosync
+ Medium: Core: Provide better feedback if Pacemaker is started by a stack it doesn't support
+ Medium: crmd: Avoid calling GHashTable functions with NULL
+ Medium: crmd: Delay raising I_ERROR when the PE exits until we've had a chance to save the current CIB
+ Medium: crmd: Hook up the stonith-timeout option to stonithd
+ Medium: crmd: Prevent potential use-of-NULL in global_timer_callback
+ Medium: crmd: Rationalize the logging of graph aborts
+ Medium: PE: Add a stonith_timeout option and remove new options that are better set in rsc_defaults
+ Medium: PE: Allow external entities to ask for a node to be shot by creating a terminate=true transient node attribute
+ Medium: PE: Bug LF:1950 - Notifications do not contain all documented resource state fields
+ Medium: PE: Bug N:417585 - Don't restart group children who's individual score drops below zero
+ Medium: PE: Detect clients that disconnect before receiving their reply
+ Medium: PE: Implement a true maintenance mode
+ Medium: PE: Implement on-fail=standby for NTT.  Derived from a patch by Satomi TANIGUCHI
+ Medium: PE: Print the correct message when stonith is disabled
+ Medium: PE: ptest - check the input is valid before proceeding
+ Medium: PE: Revert group stickiness to the 'old way'
+ Medium: PE: Use the correct attribute for action 'requires' (was prereq)
+ Medium: stonithd: Fix compilation without full heartbeat install
+ Medium: stonithd: exit with better code on empty host list
+ Medium: tools: Add a new regression test for CLI tools
+ Medium: tools: crm_resource - return with non-zero when a resource migration command is invalid
+ Medium: tools: crm_shadow - Allow the admin to start with an empty CIB (and no cluster connection)
+ Medium: xml: pacemaker-0.7 is now an alias for the 1.0 schema
* Mon Sep 22 2008 Andrew Beekhof <abeekhof@suse.de>
- version 0.7.3-1
- Update source tarball to revision: 33e677ab7764+ tip
- Statistics:
    Changesets:      133
    Diff:            89 files changed, 7492 insertions(+), 1125 deletions(-)
- Changes since f805e1b30103
+ High: Tools: add the crm cli program
+ High: Core: cl_malloc and friends were removed from Heartbeat
+ High: Core: Only call xmlCleanupParser() if we parsed anything.  Doing so unconditionally seems to cause a segfault
+ High: new hb2openais.sh conversion script
+ High: PE: Bug LF:1950 - Ensure the current values for all notification variables are always set (even if empty)
+ High: PE: Bug LF:1955 - Ensure unmanaged masters are unconditionally repromoted to ensure they are monitored correctly.
+ High: PE: Bug LF:1955 - Fix another case of filtering causing unmanaged master failures
+ High: PE: Bug LF:1955 - Umanaged mode prevents master resources from being allocated correctly
+ High: PE: Bug N:420538 - Anit-colocation caused a positive node preference
+ High: PE: Correctly handle unmanaged resources to prevent them from being started elsewhere
+ High: PE: crm_resource - Fix the --migrate command
+ High: PE: MAke stonith-enabled default to true and warn if no STONITH resources are found
+ High: PE: Make sure orphaned clone children are created correctly
+ High: PE: Monitors for unmanaged resources don't need to wait for start/promote/demote actions to complete
+ High: stonithd (LF 1951): fix remote stonith operations
+ High: Tools: crm_verify - clean up the upgrade logic to prevent crash on invalid configurations
+ Medium: ais: Add support for a synchronous call to retrieve the node's nodeid
+ Medium: ais: Use the agreed service number
+ Medium: PE: Allow external entities to ask for a node to be shot by creating a terminate=true transient node attribute
+ Medium: PE: Bug LF:1950 - Notifications do not contain all documented resource state fields
+ Medium: PE: Bug N:417585 - Don't restart group children who's individual score drops below zero
+ Medium: PE: Implement a true maintenance mode
+ Medium: PE: Print the correct message when stonith is disabled
+ Medium: stonithd: exit with better code on empty host list
+ Medium: xml: pacemaker-0.7 is now an alias for the 1.0 schema
* Wed Aug 20 2008 Andrew Beekhof <abeekhof@suse.de>
- version 0.7.1-1
- Update source tarball to revision: f805e1b30103+ tip
- Statistics:
    Changesets:      184
    Diff:            513 files changed, 43408 insertions(+), 43783 deletions(-)
- Testing Notes:
+ Test hardware:
+ All testing was performed with STONITH enabled
+ Pending bugs encountered during testing:
- Changes since 0.7.0-19
+ Fix compilation when GNUTLS isnt found
+ Hg: Use the default branch name for dev
+ High: admin: Fix use-after-free in crm_mon
+ High: Build: Remove testing code that prevented heartbeat-only builds
+ High: cib: Use single quotes so that the xpath queries for nvpairs will succeed
+ High: crmd: Always connect to stonithd when the TE starts and ensure we notice if it dies
+ High: crmd: Correctly handle a dead PE process
+ High: crmd: Make sure async-failures cause the failcount to be incrimented
+ High: PE: Bug LF:1941 - Handle failed clone instance probes when clone-max < #nodes
+ High: PE: Parse resource ordering sets correctly
+ High: PE: Prevent use-of-NULL - order->rsc_rh will not always be non-NULL
+ High: PE: Unpack colocation sets correctly
+ High: Tools: crm_mon - Prevent use-of-NULL for orphaned resources
+ Medium: ais: Add support for a synchronous call to retrieve the node's nodeid
+ Medium: ais: Allow transient clients to receive membership updates
+ Medium: ais: Avoid double-free in error path
+ Medium: ais: Include in the mebership nodes for which we haven't determined their hostname
+ Medium: ais: Spawn the PE from the ais plugin instead of the crmd
+ Medium: cib: By default, new configurations use the latest schema
+ Medium: cib: Clean up the CIB if it was already disconnected
+ Medium: cib: Only incriment num_updates if something actually changed
+ Medium: cib: Prevent use-after-free in client after abnormal termination of the CIB
+ Medium: Core: Fix memory leak in xpath searches
+ Medium: Core: Get more details regarding parser errors
+ Medium: Core: Repair expand_plus_plus - don't call char2score on unexpanded values
+ Medium: Core: Switch to the libxml2 parser - its significantly faster
+ Medium: Core: Use a libxml2 library function for xml -> text conversion
+ Medium: crmd: Asynchronous failure actions have no parameters
+ Medium: crmd: Avoid calling glib functions with NULL
+ Medium: crmd: Do not allow an election to promote a node from S_STARTING
+ Medium: crmd: Do not vote if we've not completed the local startup
+ Medium: crmd: Fix te_update_diff() now that get_object_root() functions differently
+ Medium: crmd: Fix the lrmd xpath expressions to not contain quotes
+ Medium: crmd: If we get a join offer during an election, better restart the election
+ Medium: crmd: No further processing is needed when using the LRM's API call for failing resources
+ Medium: crmd: Only update have-quorum if the value changed
+ Medium: crmd: Repair the input validation logic in do_te_invoke
+ Medium: cts: CIB's can no longer contain comments
+ Medium: cts: Enable a bunch of tests that were incorrectly disabled
+ Medium: cts: The libxml2 parser wont allow v1 resources to use integers as parameter names
+ Medium: Don't use the cluster UID and GID directly.  Look them up based on the configured value of HA_CCMUSER
+ Medium: Fix compilation when heartbeat is not supported
+ Medium: PE: Allow groups to be involved in optional ordering constraints
+ Medium: PE: Allow sets of operations to be reused by multiple resources
+ Medium: PE: Bug LF:1941 - Mark extra clone instances as orphans and don't show inactive ones
+ Medium: PE: Determin the correct migration-threshold during resource expansion
+ Medium: PE: Implement no-quorum-policy=suicide (FATE #303619)
+ Medium: pengine: Clean up resources after stopping old copies of the PE
+ Medium: pengine: Teach the PE how to stop old copies of itself
+ Medium: Tools: Backport hb_report updates
+ Medium: Tools: cib_shadow - On create, spawn a new shell with CIB_shadow and PS1 set accordingly
+ Medium: Tools: Rename cib_shadow to crm_shadow
* Fri Jul 18 2008 Andrew Beekhof <abeekhof@suse.de>
- version 0.7.0-19
- Update source tarball to revision: 007c3a1c50f5 (unstable) tip
- Statistics:
    Changesets:      108
    Diff:            216 files changed, 4632 insertions(+), 4173 deletions(-)
- Changes added since unstable-0.7
+ High: admin: Fix use-after-free in crm_mon
+ High: ais: Change the tag for the ais plugin to "pacemaker" (used in openais.conf)
+ High: ais: Log terminated processes as an error
+ High: cib: Performance - Reorganize things to avoid calculating the XML diff twice
+ High: PE: Bug LF:1941 - Handle failed clone instance probes when clone-max < #nodes
+ High: PE: Fix memory leak in action2xml
+ High: PE: Make OCF_ERR_ARGS a node-level error rather than a cluster-level one
+ High: PE: Properly handle clones that are not installed on all nodes
+ Medium: admin: cibadmin - Show any validation errors if the upgrade failed
+ Medium: admin: cib_shadow - Implement --locate to display the underlying filename
+ Medium: admin: cib_shadow - Implement a --diff option
+ Medium: admin: cib_shadow - Implement a --switch option
+ Medium: admin: crm_resource - create more compact constraints that don't use lifetime (which is deprecated)
+ Medium: ais: Approximate born_on for OpenAIS based clusters
+ Medium: cib: Remove do_id_check, it is a poor substitute for ID validation by a schema
+ Medium: cib: Skip construction of pre-notify messages if no-one wants one
+ Medium: Core: Attempt to streamline some key functions to increase performance
+ Medium: Core: Clean up XML parser after validation
+ Medium: crmd: Detect and optimize the crm's behavior when processing diffs of an LRM refresh
+ Medium: Fix memory leaks when resetting the name of an XML object
+ Medium: PE: Prefer the current location if it is one of a group of nodes with the same (highest) score
* Wed Jun 25 2008 Andrew Beekhof <abeekhof@suse.de>
- version 0.7.0-1
- Update source tarball to revision: bde0c7db74fb tip
- Statistics:
    Changesets:      439
    Diff:            676 files changed, 41310 insertions(+), 52071 deletions(-)
- Changes added since stable-0.6
+ High: A new tool for setting up and invoking CTS
+ High: Admin: All tools now use --node (-N) for specifying node unames
+ High: Admin: All tools now use --xml-file (-x) and --xml-text (-X) for specifying where to find XML blobs
+ High: cib: Cleanup the API - remove redundant input fields
+ High: cib: Implement CIB_shadow - a facility for making and testing changes before uploading them to the cluster
+ High: cib: Make registering per-op callbacks an API call and renamed (for clarity) the API call for requesting notifications
+ High: Core: Add a facility for automatically upgrading old configurations
+ High: Core: Adopt libxml2 as the XML processing library - all external clients need to be recompiled
+ High: Core: Allow sending TLS messages larger than the MTU
+ High: Core: Fix parsing of time-only ISO dates
+ High: Core: Smarter handling of XML values containing quotes
+ High: Core: XML memory corruption - catch, and handle, cases where we're overwriting an attribute value with itself
+ High: Core: The xml ID type doesn't allow UUIDs that start with a number
+ High: Core: Implement XPath based versions of query/delete/replace/modify
+ High: Core: Remove some HA2.0.(3,4) compatability code
+ High: crmd: Overhaul the detection of nodes that are starting vs. failed
+ High: PE: Bug LF:1459 - Allow failures to expire
+ High: PE: Have the PE do non-persistent configuration upgrades before performing calculations
+ High: PE: Replace failure-stickiness with a simple 'migration-threshold'
+ High: TE: Simplify the design by folding the tengine process into the crmd
+ Medium: Admin: Bug LF:1438 - Allow the list of all/active resource operations to be queried by crm_resource
+ Medium: Admin: Bug LF:1708 - crm_resource should print a warning if an attribute is already set as a meta attribute
+ Medium: Admin: Bug LF:1883 - crm_mon should display fail-count and operation history
+ Medium: Admin: Bug LF:1883 - crm_mon should display operation timing data
+ Medium: Admin: Bug N:371785 - crm_resource -C doesn't also clean up fail-count attributes
+ Medium: Admin: crm_mon - include timing data for failed actions
+ Medium: ais: Read options from the environment since objdb isn't completely usable yet
+ Medium: cib: Add sections for op_defaults and rsc_defaults
+ Medium: cib: Better matching notification callbacks (for detecting duplicates and removal)
+ Medium: cib: Bug LF:1348 - Allow rules and attribute sets to be referenced for use in other objects
+ Medium: cib: BUG LF:1918 - By default, all cib calls now timeout after 30s
+ Medium: cib: Detect updates that decrease the version tuple
+ Medium: cib: Implement a client-side operation timeout - Requires LHA update
+ Medium: cib: Implement callbacks and async notifications for remote connections
+ Medium: cib: Make cib->cmds->update() an alias for modify at the API level (also implemented in cibadmin)
+ Medium: cib: Mark the CIB as disconnected if the IPC connection is terminated
+ Medium: cib: New call option 'cib_can_create' which can be passed to modify actions - allows the object to be created if it doesn't exist yet
+ Medium: cib: Reimplement get|set|delete attributes using XPath
+ Medium: cib: Remove some useless parts of the API
+ Medium: cib: Remove the 'attributes' scaffolding from the new format
+ Medium: cib: Implement the ability for clients to connect to remote servers
+ Medium: Core: Add support for validating xml against RelaxNG schemas
+ Medium: Core: Allow more than one item to be modified/deleted in XPath based operations
+ Medium: Core: Fix the sort_pairs function for creating sorted xml objects
+ Medium: Core: iso8601 - Implement subtract_duration and fix subtract_time
+ Medium: Core: Reduce the amount of xml copying occuring
+ Medium: Core: Support value='value+=N' XML updates (in addtion to value='value++')
+ Medium: crmd: Add support for lrm_ops->fail_rsc if its available
+ Medium: crmd: HB - watch link status for node leaving events
+ Medium: crmd: Bug LF:1924 - Improved handling of lrmd disconnects and shutdowns
+ Medium: crmd: Do not wait for actions with a start_delay over 5 minutes. Confirm them immediately
+ Medium: PE: Bug LF:1328 - Don't fencing nodes in clusters without managed resources
+ Medium: PE: Bug LF:1461 - Give transient node attributes (in <status/>) preference over persistent ones (in <nodes/>)
+ Medium: PE: Bug LF:1884, Bug LF:1885 - Implement N:M ordering and colocation constraints
+ Medium: PE: Bug LF:1886 - Create a resource and operation 'defaults' config section
+ Medium: PE: Bug LF:1892 - Allow recurring actions to be triggered at known times
+ Medium: PE: Bug LF:1926 - Probes should complete before stop actions are invoked
+ Medium: PE: Fix the standby when it's set as a transient attribute
+ Medium: PE: Implement a global 'stop-all-resources' option
+ Medium: PE: Implement cibpipe, a tool for performing/simulating config changes "offline"
+ Medium: PE: We don't allow colocation with specific clone instances
+ Medium: Tools: pingd - Implement a stack-independant version of pingd
+ Medium: xml: Ship an xslt for upgrading from 0.6 to 0.7
* Thu Jun 19 2008 Andrew Beekhof <abeekhof@suse.de>
- version 0.6.5-1
- Update source tarball to revision: b9fe723d1ac5 tip
- Statistics:
    Changesets:      48
    Diff:            37 files changed, 1204 insertions(+), 234 deletions(-)
- Changes since Pacemaker-0.6.4
+ High: Admin: Repair the ability to delete failcounts
+ High: ais: Audit IPC handling between the AIS plugin and CRM processes
+ High: ais: Have the plugin create needed /var/lib directories
+ High: ais: Make sure the sync and async connections are assigned correctly (not swapped)
+ High: cib: Correctly detect configuration changes - num_updates does not count
+ High: PE: Apply stickiness values to the whole group, not the individual resources
+ High: PE: Bug N:385265 - Ensure groups are migrated instead of remaining partially active on the current node
+ High: PE: Bug N:396293 - Enforce manditory group restarts due to ordering constraints
+ High: PE: Correctly recover master instances found active on more than one node
+ High: PE: Fix memory leaks reported by Valgrind
+ Medium: Admin: crm_mon - Misc improvements from Satomi Taniguchi
+ Medium: Bug LF:1900 - Resource stickiness should not allow placement in asynchronous clusters
+ Medium: crmd: Ensure joins are completed promptly when a node taking part dies
+ Medium: PE: Avoid clone instance shuffling in more cases
+ Medium: PE: Bug LF:1906 - Remove an optimization in native_merge_weights() causing group scores to behave eratically
+ Medium: PE: Make use of target_rc data to correctly process resource operations
+ Medium: PE: Prevent a possible use of NULL in sort_clone_instance()
+ Medium: TE: Include target rc in the transition key - used to correctly determin operation failure
* Thu May 22 2008 Andrew Beekhof <abeekhof@suse.de>
- version 0.6.4-1
- Update source tarball to revision: 226d8e356924 tip
- Statistics:
    Changesets:       55
    Diff:             199 files changed, 7103 insertions(+), 12378 deletions(-)
- Changes since Pacemaker-0.6.3
+ High: crmd: Bug LF:1881 LF:1882 - Overhaul the logic for operation cancelation and deletion
+ High: crmd: Bug LF:1894 - Make sure cancelled recurring operations are cleaned out from the CIB
+ High: PE: Bug N:387749 - Colocation with clones causes unnecessary clone instance shuffling
+ High: PE: Ensure 'master' monitor actions are cancelled _before_ we demote the resource
+ High: PE: Fix assert failure leading to core dump - make sure variable is properly initialized
+ High: PE: Make sure 'slave' monitoring happens after the resource has been demoted
+ High: PE: Prevent failure stickiness underflows (where too many failures become a _positive_ preference)
+ Medium: Admin: crm_mon - Only complain if the output file could not be opened
+ Medium: Common: filter_action_parameters - enable legacy handling only for older versions
+ Medium: PE: Bug N:385265 - The failure stickiness of group children is ignored until it reaches -INFINITY
+ Medium: PE: Implement master and clone colocation by exlcuding nodes rather than setting one's score to INFINITY (similar to cs: 756afc42dc51)
+ Medium: TE: Bug LF:1875 - Correctly find actions to cancel when their node leaves the cluster
* Wed Apr 23 2008 Andrew Beekhof <abeekhof@suse.de>
- version 0.6.3-1
- Update source tarball to revision: fd8904c9bc67 tip
- Statistics:
    Changesets:      117
    Diff:            354 files changed, 19094 insertions(+), 11338 deletions(-)
- Changes since Pacemaker-0.6.2
+ High: Admin: Bug LF:1848 - crm_resource - Pass set name and id to delete_resource_attr() in the correct order
+ High: Build: SNMP has been moved to the management/pygui project
+ High: crmd: Bug LF1837 - Unmanaged resources prevent crmd from shutting down
+ High: crmd: Prevent use-after-free in lrm interface code (Patch based on work by Keisuke MORI)
+ High: PE: Allow the cluster to make progress by not retrying failed demote actions
+ High: PE: Anti-colocation with slave shouldn't prevent master colocation
+ High: PE: Bug LF 1768 - Wait more often for STONITH ops to complete before starting resources
+ High: PE: Bug LF1836 - Allow is-managed-default=false to be overridden by individual resources
+ High: PE: Bug LF185 - Prevent pointless master/slave instance shuffling by ignoring the master-pref of stopped instances
+ High: PE: Bug N-191176 - Implement interleaved ordering for clone-to-clone scenarios
+ High: PE: Bug N-347004 - Ensure clone notifications are always sent when an instance is stopped/started
+ High: PE: Bug N-347004 - Include notification ordering is correct for interleaved clones
+ High: PE: Bug PM-11 - Directly link probe_complete to starting clone instances
+ High: PE: Bug PM1 - Fix setting failcounts when applied to complex resources
+ High: PE: Bug PM12, LF1648 - Extensive revision of group ordering
+ High: PE: Bug PM7 - Ensure masters are always demoted before they are stopped
+ High: PE: Create probes after allocation to allow smarter handling of anonymous clones
+ High: PE: Don't prioritize clone instances that must be moved
+ High: PE: Fix error in previous commit that allowed more than the required number of masters to be promoted
+ High: PE: Group start ordering fixes
+ High: PE: Implement promote/demote ordering for cloned groups
+ High: TE: Repair failcount updates
+ High: TE: Use the correct offset when updating failcount
+ Medium: Admin: Add a summary output that can be easily parsed by CTS for audit purposes
+ Medium: Build: Make configure fail if bz2 or libxml2 are not present
+ Medium: Build: Re-instate a better default for LCRSODIR
+ Medium: CIB: Bug LF-1861 - Filter irrelvant error status from synchronous CIB clients
+ Medium: Core: Bug 1849 - Invalid conversion of ordinal leap year to gregorian date
+ Medium: Core: Drop compataibility code for 2.0.4 and 2.0.5 clusters
+ Medium: crmd: Bug LF-1860 - Automatically cancel recurring ops before demote and promote operations (not only stops)
+ Medium: crmd: Save the current CIB contents if we detect the PE crashed
+ Medium: PE: Bug LF:1866 - Fix version check when applying compatability handling for failed start operations
+ Medium: PE: Bug LF:1866 - Restore the ability to have start failures not be fatal
+ Medium: PE: Bug PM1 - Failcount applies to all instances of non-unique clone
+ Medium: PE: Correctly set the state of partially active master/slave groups
+ Medium: PE: Don't claim to be stopping an already stopped orphan
+ Medium: PE: Ensure implies_left ordering constraints are always effective
+ Medium: PE: Indicate each resource's 'promotion' score
+ Medium: PE: Prevent a possible use-of-NULL
+ Medium: PE: Reprocess the current action if it changed (so that any prior dependancies are updated)
+ Medium: TE: Bug LF-1859 - Wait for fail-count updates to complete before terminating the transition
+ Medium: TE: Bug LF:1859 - Don't abort graphs due to our own failcount updates
+ Medium: TE: Bug LF:1859 - Prevent the TE from interupting itself
* Thu Feb 14 2008 Andrew Beekhof <abeekhof@suse.de>
- version 0.6.2-1
- Update source tarball to revision: 28b1a8c1868b tip
- Statistics:
    Changesets:    11
    Diff:          7 files changed, 58 insertions(+), 18 deletions(-)
- Changes since Pacemaker-0.6.1
+ haresources2cib.py: set default-action-timeout to the default (20s)
+ haresources2cib.py: update ra parameters lists
+ Medium: SNMP: Allow the snmp subagent to be built (patch from MATSUDA, Daiki)
+ Medium: Tools: Make sure the autoconf variables in haresources2cib are expanded
* Tue Feb 12 2008 Andrew Beekhof <abeekhof@suse.de>
- version 0.6.1-1
- Update source tarball to revision: e7152d1be933 tip
- Statistics:
    Changesets:    25
    Diff:          37 files changed, 1323 insertions(+), 227 deletions(-)
- Changes since Pacemaker-0.6.0
+ High: CIB: Ensure changes to top-level attributes (like admin_epoch) cause a disk write
+ High: CIB: Ensure the archived file hits the disk before returning
+ High: CIB: Repair the ability to do 'atomic incriment' updates (value="value++")
+ High: crmd: Bug #7 - Connecting to the crmd immediately after startup causes use-of-NULL
+ Medium: CIB: Mask cib_diff_resync results from the caller - they don't need to know
+ Medium: crmd: Delay starting the IPC server until we're fully functional
+ Medium: CTS: Fix the startup patterns
+ Medium: PE: Bug 1820 - Allow the first resource in a group to be migrated
+ Medium: PE: Bug 1820 - Check the colocation dependancies of resources to be migrated
* Mon Jan 14 2008 Andrew Beekhof <abeekhof@suse.de>
- version 0.6.0-2
- This is the first release of the Pacemaker Cluster Resource Manager formerly part of Heartbeat.
- For those looking for the GUI, mgmtd, CIM or TSA components, they are now found in
  the new pacemaker-pygui project.  Build dependancies prevent them from being
  included in Heartbeat (since the built-in CRM is no longer supported) and,
  being non-core components, are not included with Pacemaker.
- Update source tarball to revision: c94b92d550cf
- Statistics:
    Changesets:      347
    Diff:            2272 files changed, 132508 insertions(+), 305991 deletions(-)
- Test hardware:
  + 6-node vmware cluster (sles10-sp1/256Mb/vmware stonith) on a single host (opensuse10.3/2Gb/2.66Ghz Quad Core2)
  + 7-node EMC Centera cluster (sles10/512Mb/2Ghz Xeon/ssh stonith)
- Notes: Heartbeat Stack
  + All testing was performed with STONITH enabled
  + The CRM was enabled using the "crm respawn" directive
  + Testing
    2-nodes ::= 1000 CTS iterations (passed)
    4-nodes ::= 1000 CTS iterations (passed)
    6-nodes ::= 2000 CTS iterations (passed)
  + Total estimated cluster transitions: 18000
- Notes: OpenAIS Stack
  + This release contains a preview of support for the OpenAIS cluster stack
  + The current release of the OpenAIS project is missing two important
    patches that we require.  OpenAIS packages containing these patches are
    available for most major distributions at:
      http://download.opensuse.org/repositories/server:/ha-clustering
  + The OpenAIS stack is not currently recommended for use in clusters that
    have shared data as STONITH support is not yet implimented
  + pingd is not yet available for use with the OpenAIS stack
  + 3 significant OpenAIS issues were found during testing of 4 and 6 node
    clusters.  We are activly working together with the OpenAIS project to
    get these resolved.
  + Testing
    2-nodes ::= 1000 CTS iterations (passed)
    4-nodes ::= 1000 CTS iterations (sporadic problems - see pending bugs)
    6-nodes ::= 1000 CTS iterations (significant problems - see pending bugs)
  + Total estimated cluster transitions: 12000
- Pending bugs encountered during testing:
  + OpenAIS   #1736 - Openais membership took 20s to stabilize
  + Heartbeat #1750 - ipc_bufpool_update: magic number in head does not match
  + OpenAIS   #1793 - Assertion failure in memb_state_gather_enter()
  + OpenAIS   #1796 - Cluster message corruption
- Changes since Heartbeat-2.1.2-24
+ High: Add OpenAIS support
+ High: Admin: crm_uuid - Look in the right place for Heartbeat UUID files
+ High: admin: Exit and indicate a problem if the crmd exits while crmadmin is performing a query
+ High: cib: Fix CIB_OP_UPDATE calls that modify the whole CIB
+ High: cib: Fix compilation when supporting the heartbeat stack
+ High: cib: Fix memory leaks caused by the switch to get_message_xml()
+ High: cib: HA_VALGRIND_ENABLED needs to be set _and_ set to 1|yes|true
+ High: cib: Use get_message_xml() in preference to cl_get_struct()
+ High: cib: Use the return value from call to write() in cib_send_plaintext()
+ High: Core: ccm nodes can legitimately have a node id of 0
+ High: Core: Fix peer-process tracking for the Heartbeat stack
+ High: Core: Heartbeat doesn't send status notifications for nodes that were already part of the cluster.  Fake them instead
+ High: CRM: Add children to HA_Messages such that the field name matches F_XML_TAGNAME
+ High: crm: Adopt a more flexible appraoch to enabling Valgrind
+ High: crm: Fix compilation when bzip2 is not installed
+ High: CRM: Future-proof get_message_xml()
+ High: crmd: Filter election responses based on time not FSA state
+ High: crmd: Handle all possible peer states in crmd_ha_status_callback()
+ High: crmd: Make sure the current date/time is set - prevents use-of-NULL when evaluating rules
+ High: crmd: Relax an assertion regrading  ccm membership instances
+ High: crmd: Use (node->processes&crm_proc_ais) to accurately update the CIB after replace operations
+ High: crmd: Heartbeat: Accurately record peer client status
+ High: PE: Bug 1777 - Allow colocation with a resource in the Stopped state
+ High: PE: Bug 1822 - Prevent use-of-NULL in PromoteRsc()
+ High: PE: Implement three recovery policies based on op_status and op_rc
+ High: PE: Parse fail-count correctly (it may be set to ININFITY)
+ High: PE: Prevent graph-loop when stonith agents need to be moved around before a STONITH op
+ High: PE: Prevent graph-loops when two operations have the same name+interval
+ High: te: Cancel active timers when destroying graphs
+ High: TE: Ensure failcount is set correctly for failed stops/starts
+ High: TE: Update failcount for oeprations that time out
+ Medium: admin: Prevent hang in crm_mon -1 when there is no cib connection - Patch from Junko IKEDA
+ Medium: cib: Require --force|-f when performing potentially dangerous commands with cibadmin
+ Medium: cib: Tweak the shutdown code
+ Medium: Common: Only count peer processes of active nodes
+ Medium: Core: Create generic cluster sign-in method
+ Medium: core: Fix compilation when Heartbeat support is disabled
+ Medium: Core: General cleanup for supporting two stacks
+ Medium: Core: iso6601 - Support parsing of time-only strings
+ Medium: core: Isolate more code that's only needed when SUPPORT_HEARTBEAT is enabled
+ Medium: crm: Improved logging of errors in the XML parser
+ Medium: crmd: Fix potential use-of-NULL in string comparison
+ Medium: crmd: Reimpliment syncronizing of CIB queries and updates when invoking the PE
+ Medium: crm_mon: Indicate when a node is both in standby mode and offline
+ Medium: PE: Bug 1822 - Don't try an promote groups if not all of it is active
+ Medium: PE: on_fail=nothing is an alias for 'ignore' not 'restart'
+ Medium: PE: Prevent a potential use-of-NULL in cron_range_satisfied()
+ snmp subagent: fix a problem on displaying an unmanaged group
+ snmp subagent: use the syslog setting
+ snmp: v2 support (thanks to Keisuke MORI)
+ snmp_subagent - made it not complain about some things if shutting down
* Mon Dec 10 2007 Andrew Beekhof <abeekhof@suse.de>
- version 0.6.0-1
- Initial package check-in
